/** MIT License
* 
* Copyright (c) 2018 Ludovic CLUBER 
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* http://csvxjs.lcluber.com
*/

var CSVx=function(t){"use strict";function n(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,o=new Array(e);r<e;r++)o[r]=t[r];return o}function h(t,e){var r;if("undefined"==typeof Symbol||null==t[Symbol.iterator]){if(Array.isArray(t)||(r=function(t,e){if(t){if("string"==typeof t)return n(t,e);var r=Object.prototype.toString.call(t).slice(8,-1);return"Object"===r&&t.constructor&&(r=t.constructor.name),"Map"===r||"Set"===r?Array.from(t):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?n(t,e):void 0}}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var o=0;return function(){return o>=t.length?{done:!0}:{done:!1,value:t[o++]}}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}return(r=t[Symbol.iterator]()).next.bind(r)}function i(t){return null!==t&&"object"==typeof t&&!(null!==(e=t)&&e.constructor===Array);var e}var e=function(){function t(){}return t.data=function(t,e,r){for(var o,n=h(e);!(o=n()).done;){if(!i(o.value))return!1}t||(t="export"),r&&this.setOptions(r);var s="",a=[];return a=this.options.customLabels?this.createCustomLabels(this.options.customLabels):this.createLabels(e),this.options.labels&&(s+=this.createLabelsRow(a)),s+=this.createTable(e),this.download(s,t),!0},t.setOptions=function(t){for(var e in t)t.hasOwnProperty(e)&&this.options.hasOwnProperty(e)&&(this.options[e]=t[e]||this.options[e])},t.download=function(t,e){var r="data:"+this.options.data+";charset="+this.options.charset+","+escape(t);if(window.navigator.msSaveOrOpenBlob)window.navigator.msSaveOrOpenBlob(r,e);else{var o=document.createElement("a");o.setAttribute("href",r),o.setAttribute("download",e+".csv"),document.body.appendChild(o),o.click(),document.body.removeChild(o)}},t.createTable=function(t){for(var e,r,o="",n=h(t);!(r=n()).done;){var s=r.value,a="";for(var i in this.options.customLabels)this.options.customLabels.hasOwnProperty(i)&&(a+=this.createField(null!==(e=s[i])&&void 0!==e?e:""));o+=this.createRow(a)}return o},t.createLabels=function(t){for(var e,r=[],o=h(t);!(e=o()).done;){var n=e.value,s=0,a=function(e){n.hasOwnProperty(e)&&(r.find(function(t){return t===e})||r.splice(s,0,e),s++)};for(var i in n)a(i)}this.options.customLabels={};for(var u=0,c=r;u<c.length;u++){var l=c[u];this.options.customLabels[l]=l}return r},t.createCustomLabels=function(t){var e=[];for(var r in t)t.hasOwnProperty(r)&&e.push(t[r]);return e},t.createLabelsRow=function(t){for(var e,r="",o=h(t);!(e=o()).done;){var n=e.value;r+=this.createField(n)}return this.createRow(r)},t.createRow=function(t){return t.slice(0,-1)+this.options.CRLF},t.createField=function(t){return this.options.quote+t+this.options.quote+this.options.separator},t}();e.options={data:"text/csv",charset:"utf-8",labels:!0,quote:'"',separator:",",CRLF:"\r\n",customLabels:null};var r=function(){function t(){}return t.setOptions=function(t){this.setObject("options",t)},t.setCSS=function(t){this.setObject("css",t)},t.array=function(t,e,r){e&&this.setOptions(e),r&&this.setCSS(r);var o=t.trim().split(this.options.CRLF).filter(Boolean);if(!o.length)return!1;for(var n,s=[],a=h(o);!(n=a()).done;){var i=n.value.split(this.options.separator);if(this.options.quote)for(var u=0;u<i.length;u++)i[u]=i[u].slice(1,-1);s.push(i)}return s},t.table=function(t,e,r){var o=this.array(t,e,r);if(o){for(var n="",s=[],a=0;a<o.length;a++){var i="td",u="";!a&&this.options.labels?(i="th",this.css.th&&(u=' class = "'+this.css.th+'"'),n="<thead>"+this.createTr(o[a],i,u)+"</thead>"):s.push(this.createTr(o[a],i,""))}if(n||s.length)return"<table "+(this.css.table?'class="'+this.css.table+'"':"")+">"+n+"<tbody>"+s.join("")+"</tbody></table>"}return!1},t.createTr=function(t,e,r){return"<tr><"+e+r+">"+t.join("</"+e+"><"+e+r+">")+"</"+e+"></tr>"},t.setObject=function(t,e){for(var r in e)e.hasOwnProperty(r)&&this[t].hasOwnProperty(r)&&(this[t][r]=e[r])},t}();return r.options={labels:!0,quote:'"',separator:",",CRLF:"\r\n"},r.css={table:"",th:""},t.Convert=r,t.Export=e,t}({});